//
// Send Net
//

local netSend = {
    ["ready"] = 0,
    ["testConnection"] = 1,
    ["getConfig"] = 2,
    ["saveConfig"] = 3,
    ["takeScreenShot"] = 4,
    ["restartMap"] = 5,
    ["verifyMe"] = 6,
    ["getSingleUseToken"] = 7,
    ["getMultiUseToken"] = 8
}

function gmInte.SendNet(id, args, func)
    net.Start("gmIntegration")
        net.WriteUInt(netSend[id], 8)
        net.WriteString(util.TableToJSON(args || {}))
        if (func) then func() end
    net.SendToServer()
end

//
// Receive Net
//

local netReceive = {
    [1] = function(data)
        gmInte.discordSyncChatPly(data)
    end,
    [2] = function(data)
        gmInte.openConfigMenu(data)
    end,
    [3] = function(data)
        gmInte.showTestConnection(data)
    end,
    [4] = function(data)
        gmInte.takeScreenShot(data.serverID, data.authToken)
    end,
    [5] = function(data)
        gmInte.config = data
    end,
    [6] = function(data)
        gmInte.chatAddText(data)
    end,
    [7] = function()
        gmInte.openVerifPopup()
    end,
    [8] = function(data)
        gmInte.singleUseToken(data)
    end,
    [9] = function(data)
        gmInte.multiUseToken(data)
    end
}

net.Receive("gmIntegration", function()
    local id = net.ReadUInt(8)
    local args = util.JSONToTable(net.ReadString())
    if (netReceive[id]) then netReceive[id](args) end
end)